class Lab:
    def __init__(self, desks, monitors):
        self.desks = desks
        self.monitors = monitors
        self.neighbors = []

    def add_neighbor(self, neighbor):
        self.neighbors.append(neighbor)
    
    def check(self):
        desk_count = self.desks
        mon_count = self.monitors
        for n in self.neighbors:
            desk_count += n.desks
            mon_count += n.monitors
        print("monitors" if mon_count > desk_count else "desks" if mon_count < desk_count else "same")
    
    def add(self, item, count):
        """
        remaining = count
        if item == "desk":
            for n in self.neighbors:
                if n.desks < remaining:
                    remaining -= n.desks
                    n.desks = 0
                else:
                    self.desks += count
                    n.desks -= remaining
                    break
        else:
            for n in self.neighbors:
                if n.monitors < remaining:
                    remaining -= n.monitors
                    n.monitors = 0
                else:
                    self.monitors += count
                    n.monitors -= remaining
                    break"""
        if item == "desk":
            self.desks += count
        else:
            self.monitors += count


    def print(self):
        print(f"d:{self.desks}; m:{self.monitors}")

line1 = input()
tmp_arg = line1.split()

lab_count = int(tmp_arg[0])
lab_neighbour_count = int(tmp_arg[1])
query_count = int(tmp_arg[2])

desks = []
line2 = input().split()
for elem in line2: desks.append(int(elem))

monitors = []
line3 = input().split()
for elem in line3: monitors.append(int(elem))


labs = []
for i in range(0,lab_count):
    labs.append(Lab(desks[i],monitors[i]))

for i in range(0, lab_neighbour_count):
    linex = input().split()
    l1 = int(linex[0]) -1
    l2 = int(linex[1]) -1

    labs[l1].add_neighbor(labs[l2])
    labs[l2].add_neighbor(labs[l1])

for i in range(0, query_count):
    query = input().split()

    if query[0] == "check":
        labs[int(query[1])-1].check()
    elif query[0] == "add":
        labs[int(query[3])-1].add(query[2], int(query[1]))
        

