#include <bits/stdc++.h>
using namespace std;

class Lab {
public:
    int desks = 0;
    int monitors = 0;
    vector<Lab*> neighbors;
    void check() {
        int total_desks = desks;
        int total_monitors = monitors;
        for (Lab* l : neighbors) {
            total_desks += l->desks;
            total_monitors += l->monitors;
        }
        if (total_desks < total_monitors) {
            cout << "monitors\n";
        }
        else if (total_desks > total_monitors) {
            cout << "desks\n";
        }
        else {
            cout << "same\n";
        }
    }
    void add(string item, int count) {
        if (item == "monitor") {
            monitors += count;
        }
        else {
            desks += count;
        }
    }
};

int main(){
    int l, n, q;
    cin >> l >> n >> q;
    vector<int> monitors;
    vector<int> desks;
    vector<Lab> labs;
    labs.reserve(l);

    for (int i = 0; i < l; i++) {
        int x;
        cin >> x;
        labs[i].desks = x;
    }
    for (int i = 0; i < l; i++){
        int x;
        cin >> x;
        labs[i].monitors = x;
    }

    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        labs[a-1].neighbors.push_back(&labs[b-1]);
        labs[b-1].neighbors.push_back(&labs[a-1]);
    }

    for (int i = 0; i < q; i++){
        string command;
        cin >> command;
        if (command == "check") {
            int label;
            cin >> label;
            labs[label - 1].check();
        }
        else {
            int count;
            string type;
            int label;
            cin >> count >> type >> label;
            labs[label - 1].add(type, count);
        }
    }

    return 0;
}

